SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

















ALTER                 PROCEDURE [dbo].[A_DB_RemoveTails] AS
begin

		
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4)) and not (LineId in (Select [ID] From A_ServerIntLines union all Select ID From A_ServerUSBLines))
		Delete FROM A_ServerExtLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerIntLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerGSMLines where not [ServerID] in (Select [id] from A_WORKPLACES)
		Delete FROM A_ServerUSBLines where not [ServerID] in (Select [id] from A_WORKPLACES)
	
		Delete FROM A_ServerUSBLines where not [id] in (Select LineID from A_WORKPLACES)
		Delete FROM A_LinesReactors where not [WPID] in (Select [id] from A_WORKPLACES)
		Delete From A_LinesReactors where not LineID in (Select [ID] from A_ServerExtLines 
								union Select [ID] from A_ServerIntLines
								union Select [ID] from A_ServerGSMLines
								union Select [ID] from A_ServerUSBLines)
		delete from A_ServerNumbers where not [id] in (Select [ID] FROM A_WorkPlaces Where type=5)
		delete from A_ServerNumbers where [id] in (Select [ID] from A_WorkPlaces where hasdatabase>0)



		declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] from A_WORKPLACES union 
			Select [id] from A_Users union
			Select [id] from A_ServerExtLines union
			Select [id] from A_ExtNumbers union
			Select [id] from A_ServerIntLines union
			Select [id] from A_ServerUSBLines 

			Delete FROM A_USERPERMISSIONSLINES where not [IDofRec] in (Select id_ from @t)
		
		Delete From A_RuleRecords where not RuleID in (Select ID from A_Rules)

		Delete from A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ from @t ))

		Delete from A_NumberPlanAction where numtype=0 and extraid not in (Select ID from A_Rules)
		delete from A_NumberPlan where id not in (Select numid from A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID from A_NumberPlan)
		Delete From A_Rules	Where not id in ( select ruleid from A_RuleRecords )		

		delete from A_TaskManager_TaskExtLines where not ExtLineId in ( Select id from A_ServerExtLines )
		delete from A_TaskManager_Operators where not OperatorId in ( Select id from A_Users union Select Id from C_Groups )


		-----------------------------------------------------
		-- ⠢塞 ⢠ 짮⥫ -----------
		-----------------------------------------------------
		declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory

		Select 	newid(), ush.UserId, 0, @lastpingtime, '짮⥫ ⢠', 0
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		Update A_TaskManager_UserInTask
		Set TimeStop = @lastpingtime 
		Where TimeStop is null

		Update A_TaskManager_UserInTask
		Set TimeStopPriorHandling = TimeStop
		Where TimeStopPriorHandling is null


		Delete From A_Monopoly
		Delete From C_MonopolyForTaskChanging

		declare @uid table ( id uniqueidentifier )
		Insert into @uid
			Select Id From A_Users
		Delete From A_UserControls
			Where not UserA in (Select id from @uid)
				or not UserB in (Select id from @uid)
		-----------------------------------------------------
		-----------------------------------------------------

		exec A_Admin_UserGroup_Group_SiftEmpty


end
















GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

