

CREATE procedure [dbo].[A_Stat_MyCalls_Get]
	@media 	int, --1 - , 2 - , 3 - , 0 - 
	@type 	int, --1 - , 2 - , 3 - , 0 - 
	@dstart datetime,
	@dstop 	datetime,
	@number nvarchar ( 50 ),
	@userid uniqueidentifier
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set @media = 0
	set @type = 0
	set @dstart = '20.11.2006'
	set @dstop = '20.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'


	set @media = 0
	set @type = 0
	set @dstart = '  4 2006 12:00AM'
	set @dstop = ' 26 2006 11:59PM'
	set @number = ''
	set @userid = '2A594B51-BB89-4DA6-A69F-F48761BAF0D9'
*/

		Declare @ids table ( id uniqueidentifier, idchain uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id, IdChain
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
	else
		Insert into @ids
			Select Id, IdChain
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	

	Declare @chains table ( idchain uniqueidentifier )
	Insert Into @chains
		Select IdChain 
		From @ids ids
		Group By IdChain

	
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, Length DateTime, Number nvarchar ( 50 ), AbonentName nvarchar ( 100 ), IsRecorded int, ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), AUserId uniqueidentifier, BUserId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier, AOutNumber nvarchar ( 50 ), BOutNumber nvarchar ( 50 ) )
	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, '', '', IsRecorded, ARecFile, BRecFile, AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber
		From A_Stat_Connections_1x1 sc
			inner join @ids ids on sc.Id = ids.id

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	Update o
	Set o.AbonentName = 'IVR'
	From @output o
	Where o.ALineId = '00000000-0000-0000-0000-000000000000' or o.BLineId = '00000000-0000-0000-0000-000000000000'

	Select Id, IdChain, Media, Type, TimeStart, Length, Number, AbonentName, IsRecorded, ARecFile, BRecFile
	From @output
	Where Media = @media or @media = 0
	Order By TimeStart Desc

end


GO



