
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_TaskManager_AllTask_Get' ) )
	Drop procedure dbo.A_TaskManager_AllTask_Get
GO


Create Procedure dbo.A_TaskManager_AllTask_Get
as

begin
	select 	
		Id,
		IdProject,
		Name,
		Active,
		Done,
		Type,
		IvrName,
		StopReason,
		TalkScript,
		PauseWhenBusy,
		PauseWhenNotRespond,
		MaxEffortCountBusy,
		MaxEffortCountNotRespond,
		MinTimeToCheckDone,
		TryConnectTime,
		ChoiceOperator,
		DeleteAfterSuccess,
		IsExtNumber,
		IsOutputTask,
		Resulted,
		ResultType,
		ResultInfo,
		ResultDateTime,
		CreationUserId,
		CreationType,
		CreationDateTime,
		StartRunDateTime,
		StopRunDateTime,
		CanAddDynamically,
		TagDouble,
		ListId,
		OperatorShowQuery,
		OperatorShowNotify,
		ProgressCall,
		ProgressCallMaxCount,
		ProgressCallKeepQueue,
		PredictCall,
		PredictCallOffsetSec,
		QueueUse,
		QueueMaxCount,
		QueueMusic,
		QueueLoyality,
		ChoiceAbonent,
		ChoiceNumber,
		ChoiceTable,
		ChoiceProgress,
		DontSetDone,
		PauseSyncListWaitingNewAbonent,
		IncomingCallsMaxCount,
		ServiceScript,
		DialCallerId,
		IncomingUpdateIfExists,
		ActiveOnHolidays,
		Code,
		PauseSyncListForcedSec,
		QueueMaxTimeMinutes,
		PredictCallErrProbability,
		QueueRandomFromPath,
		SaveDB,
		DirectDbMethod,
		DirectDbMethodProc,
		case when ( Stream is null ) then 0 else DataLength ( Stream ) end,
		Stream
	
	from A_TaskManager_Tasks t
		Left join A_TaskManager_TaskProperties tp on t.Id = tp.IdTask
	
end
GO

