exec sp_dboption N'oktell_cc_temp', N'autoclose', N'false'
GO

exec sp_dboption N'oktell_cc_temp', N'autoshrink', N'true'
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_OperatorLastConnected_Get' ))
	Drop procedure dbo.A_CallCenter_OperatorLastConnected_Get
GO

Create procedure dbo.A_CallCenter_OperatorLastConnected_Get
	@idtask uniqueidentifier,
	@idpoint int,
	@number nvarchar ( 30 ),
	@searchintask bit,
	@searchinnumbers bit
as
begin

if ( @searchintask = 1 )
begin
	if ( @searchinnumbers = 1 )
	begin
		Select idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where IdTask = @idtask and AbonentNumber = @number
		Order by DateTimeStart Desc
	end
	else
	begin
		Select idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where IdTask = @idtask and IdInList = @idpoint
		Order by DateTimeStart Desc
	end
end
else
begin
	if ( @searchinnumbers = 1 )
	begin
		Select idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where AbonentNumber = @number
		Order by DateTimeStart Desc
	end
	else
	begin
		Select idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where IdInList = @idpoint
		Order by DateTimeStart Desc
	end
end
	
end
GO