
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_CallCenter_UserStateHistory_GetToday' ) )
	drop procedure dbo.A_CallCenter_UserStateHistory_GetToday
GO

Create procedure dbo.A_CallCenter_UserStateHistory_GetToday
	@dtnow datetime = null
as
begin

	if ( @dtnow is null )
		Set @dtnow = GetDate()

	declare @dttoday datetime
	set @dttoday = cast ( Floor ( cast ( @dtnow as float ) ) as DateTime )

	Select OperatorId, Sum ( Cast ( IsNull ( TimeLeave, @dtnow ) - case when ( TimeEnter < @dttoday ) then @dttoday else TimeEnter end as float ) ) 
	From A_CallCenter_UserStateHistory
	Where ( TimeLeave is null or TimeLeave > @dttoday )
		And State = 3
	Group By OperatorId

end
GO