if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint' ) )
	drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
GO

Create Procedure dbo.A_TaskManager_TaskOut_UpdateResult_DirectDbCachePoint
	@idtask uniqueidentifier,
	@id 	int,
	@state 	int,
	@tasktype int = 0
as
begin
	declare @tableidx nvarchar ( 200 )
	set @tableidx = 'dbo.[A_TaskManager_Idx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'
	
	declare @tableidxd nvarchar ( 200 )
	set @tableidxd = 'dbo.[A_TaskManager_dIdx_' + cast ( @idtask as nvarchar ( 50 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	if ( exists ( select * from sysobjects where id = object_id ( @tableidx ) ) and (( @tasktype = 0 ) or ( @tasktype = 1 )) )
 	begin
		Set @sql = ' Update ' + @tableidx + ' Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
	
		exec sp_sqlexec @sql
	end
	
	if ( exists ( select * from sysobjects where id = object_id ( @tableidxd ) ) and (( @tasktype = 0 ) or ( @tasktype = 2 )) )
  	begin
		Set @sql = ' Update ' + @tableidxd + ' Set State = ' + cast ( @state as nvarchar ( 10 ) )+ ' Where Id = ' + cast ( @id as nvarchar ( 10 ) )
			
		exec sp_sqlexec @sql
	end
	
end
GO