
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create' ) )
	drop procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create
GO


Create procedure dbo.A_TaskManager_List_DistrDirectDb_IdNumCache_Create
	@taskid uniqueidentifier,
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@colid nvarchar ( 100 ),
	@colsphone nvarchar ( 1000 )
	
as
begin


------------------------------------------------------------
/*
declare @table nvarchar ( 100 )
declare @colid nvarchar ( 100 )
declare @taskid uniqueidentifier
declare @colsphone nvarchar ( 1000 )
declare @query nvarchar ( 4000 )

Select @taskid = '2528AE7C-5180-441B-8B08-BB3ABCCC7CA0', @colid = N'_', @colsphone = N' IsNull ( [], '''' )  + '', '' +  IsNull ( [2], '''' ) ', @table = N't2'
*/
----------------------------------------------------------

	declare @temptable nvarchar (100 )
	set @temptable = 'dbo.[t_cache1_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @temptable2 nvarchar (100 )
	set @temptable2 = 'dbo.[t_cache2_' + cast ( @taskid as nvarchar (100 ) ) + ']'

	declare @tableidx nvarchar (100), @tableidxconstr nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'
	set @tableidxconstr = 'A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) )
	


	declare @sql nvarchar ( 4000 )

	----------------------

	set @sql = '
		If not exists ( select * FROM sysobjects where id = object_id ( ''' + @tableidx + ''' ) )
			Create Table ' + @tableidx + ' ( id int not null, Phone nvarchar ( 50 ) not null )
		'

	exec sp_executesql @sql

	set @sql = '
		if not exists ( select s.name, s.parent_obj, s1.name from sysobjects s
			inner join sysobjects s1 on s.parent_obj = s1.Id where s.name like ''PK_' + @tableidxconstr + ''' )
			ALTER TABLE ' + @tableidx + ' ADD CONSTRAINT [PK_' + @tableidxconstr + '] PRIMARY KEY CLUSTERED 
			( [Id], [Phone] )  ON [PRIMARY] 
		'
			
	exec sp_executesql @sql

	set @sql = 'Truncate table ' + @tableidx

	exec sp_executesql @sql

	----------------------
	
	begin tran CreateIdNumCache

	----------------------

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		'

	exec sp_executesql @sql
	
	----------------------

	set @sql = '
	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql
	
	-----------------------

	declare @dt datetime, @dt1 datetime
	set @dt = GetDate()

	set @sql = '
		Select ' + @colid + ' as Id,
			Replace ( Replace ( Replace (
			Replace ( Replace ( Replace ( 
			Replace ( Replace ( Replace (
			Replace ( Replace (
				''^'' + ' + @colsphone + ' + ''$'', 
				''^, '', ''^'' ), ''^, '', ''^'' ), ''^, '', ''^'' ),
				'', $'', ''$'' ), '', $'', ''$'' ), '', $'', ''$'' ),
				'', ,'', '', ''), '', ,'', '', ''), '', ,'', '', ''),
			''^'', '''' ), ''$'', '''' ) as Phone into ' + @temptable + '
		From '
	if ( Len ( @table ) > 0 )
		set @sql = @sql + @table
	else
		set @sql = @sql + '( ' + @query + ' )a'
		
	exec sp_executesql @sql

	----------------------

	declare @tt nvarchar ( 100 )
	set @tt = @temptable

	set @sql = '
		Insert into ' + @tableidx + '
			Select * From ' + @tt + ' 
			Where not Phone like ''%,%'' 
				and not Phone like ''%;%''
				and not Phone like ''''
		'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part3     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )


	set @sql = '
		Declare ucursor Cursor LOCAL FAST_FORWARD For 
			Select Id, Phone From ' + @tt + ' Where Phone like ''%,%'' or Phone like ''%;%''

		declare @id int, @phone nvarchar ( 1000 )

		Open ucursor
		Fetch Next From ucursor Into @id, @phone

		While ( @@fetch_status = 0 )
		   begin	
			declare @i int, @j1 int, @j2 int, 
				@j2_1 int, @j2_2 int,
				@ph nvarchar ( 50 )
	
			set @i = 0
			set @j1 = 1
			set @j2 = 0
			
			set @j2_1 = 0
			set @j2_2 = 0
			
			set @j2_1 = charindex ( '','', @phone, @j1 ) 
			set @j2_2 = charindex ( '';'', @phone, @j1 )
			if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
				set @j2 = @j2_1
			else
				set @j2 = @j2_2

			while @j2 > 0 or @i = 0
			begin		
				if ( @j2 = 0 )
				begin
					set @j2 = len ( @phone ) + 1
					set @i = 1
				end
	
				select @ph = REPLACE ( REPLACE ( REPLACE ( REPLACE ( 
					LTRIM ( RTRIM ( substring ( @phone, @j1, @j2-@j1 ) ) ), 
					'' '', '''' ), ''('', '''' ), '')'', '''' ), ''-'', '''' )

				if ( Len ( @ph ) > 0 )
					if not exists ( select id from ' + @tableidx + ' where id = @id and Phone = @ph )
						Insert into ' + @tableidx + ' Values ( @id, @ph )

				select @j1 = @j2 + 1, @j2 = 0
				
				set @j2_1 = charindex ( '','', @phone, @j1 ) 
				set @j2_2 = charindex ( '';'', @phone, @j1 )
				if (( @j2_1 < @j2_2 ) and ( @j2_1 > 0 )) or ( @j2_2 <= 0 )
					set @j2 = @j2_1
				else
					set @j2 = @j2_2
			end
	
	

			Fetch Next From ucursor Into @id, @phone
		   end

		Close ucursor
		Deallocate ucursor
	'

	exec sp_executesql @sql


--	set @dt1 = GetDate() - @dt
--	print 'part4     ' + cast ( DatePart ( hh, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( mi, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ss, @dt1 ) as nvarchar ( 10 ) ) + ':' + cast ( DatePart ( ms, @dt1 ) as nvarchar ( 10 ) )

	
	----------------------

	set @sql = '	
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable + ''' ) )
			drop table ' + @temptable + ' 
		
		if exists ( select * from sysobjects where id = object_id ( ''' + @temptable2 + ''' ) )
			drop table ' + @temptable2 + ' 
		'

	exec sp_executesql @sql

	----------------------

	Commit tran CreateIdNumCache


end
GO
