if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Admin_ClientForm_GetFomListControls' ) )
	drop procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
GO

Create Procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
as
begin
 Select f.idForm, f.Name 'Form', fl.IdFormList, fl.Name 'List', fc.idFormControl, fc.Name 'Control'
 From A_ClientForm  f
	inner join A_ClientFormList fl on f.idForm = fl.idForm
		inner join A_ClientFormControl fc on f.idForm = fc.idForm
 order by 1, 3, 5
end
GO
