if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_GetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_GetValue]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SetValue]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SetValue]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO
















CREATE           Procedure [dbo].[A_CallCenter_Office_Contragents_GetValue]

@@idContragent uniqueidentifier,
@@idFormBinded uniqueidentifier,
@@idFormCurrent uniqueidentifier,
@@idFormListBinded uniqueidentifier,
@@idFormListCurrent uniqueidentifier,
@@idFormControl uniqueidentifier,
@@IndexToValue int = 0
as
begin

--Consts
declare @cValueUsedLink nvarchar(50)
set @cValueUsedLink = 'ValueLink'

--Define Current List & Form
if( @@idFormBinded = '00000000-0000-0000-0000-000000000000')
  set @@idFormBinded = @@idFormCurrent
if( @@idFormListBinded = '00000000-0000-0000-0000-000000000000')
  set @@idFormListBinded = @@idFormListCurrent

--Define Field To select data
declare @ColumnName nvarchar(50)
declare @sql nvarchar(1000)
if( not exists( 
		select ValueUsed 
		from A_Clients_ClientForms 
		Where idContragent = @@idContragent and idForm = @@idFormBinded and idFormList = @@idFormListBinded and idFormControl = @@idFormControl 
  ) )
	insert 	A_Clients_ClientForms ( idValue, idForm, idFormList, idFormControl, idContragent, ValueUsed, idValueParent  ) 
		Values ( NEWID ( ) , @@idFormBinded, @@idFormListBinded, @@idFormControl, @@idContragent, 'ValueStr', NEWID ( )  )

if @@IndexToValue = 2 --    ""
	select @ColumnName = 'ValueDate2'
else -- 
	select @ColumnName = ValueUsed 
		from A_Clients_ClientForms 
		Where idContragent = @@idContragent and idForm = @@idFormBinded and idFormList = @@idFormListBinded and idFormControl = @@idFormControl
 
if( @ColumnName != @cValueUsedLink ) --Get From 
begin
	set @sql = 
		'select @ColumnName 
		from A_Clients_ClientForms 
		Where idContragent = ''@@idContragent'' and idForm = ''@@idFormBinded'' and idFormList = ''@@idFormListBinded'' and idFormControl = ''@@idFormControlCurrent'''
	set @sql = replace( @sql, '@ColumnName', @ColumnName )
	set @sql = replace( @sql, '@@idContragent', @@idContragent )
	set @sql = replace( @sql, '@@idFormBinded', @@idFormBinded )
	set @sql = replace( @sql, '@@idFormListBinded', @@idFormListBinded )
	set @sql = replace( @sql, '@@idFormControlCurrent', @@idFormControl )
	print @sql
	exec sp_sqlexec  @sql
end
else begin --ValueLink

	---Define user table field - source of current link
	declare @idValue uniqueidentifier
	declare @idValueParent uniqueidentifier
	declare @ValueUsed nvarchar(25) 
	select @idValue = idValue, @idValueParent = idValueParent,  @ValueUsed = ValueUsed
		from A_Clients_ClientForms 
		Where idContragent = @@idContragent and idForm = @@idFormBinded and idFormList = @@idFormListBinded and idFormControl = @@idFormControl
	--Search for Target Value
	while ( @ValueUsed = @cValueUsedLink )
	begin
		print @idValue
		select @idValue = idValue,  @ValueUsed = ValueUsed
		from A_Clients_ClientForms 
		Where idValue = @idValueParent
		set @idValueParent = @idValue
	end

	--Define Column Name - source of Value 
	declare @ColumnNameParent nvarchar(50)
	if @@IndexToValue = 2 --    ""
		select @ColumnNameParent = 'ValueDate2'
	else
		select @ColumnNameParent =  ValueUsed
			from A_Clients_ClientForms 
			Where idValue = @idValue
	--Define target Value
	set @sql = 
		'select @ColumnNameParent
		from A_Clients_ClientForms 
		Where idValue = ''@idValue'''
	set @sql = replace( @sql, '@ColumnNameParent', @ColumnNameParent )
	set @sql = replace( @sql, '@idValue', @idValue )
	exec sp_sqlexec  @sql
end
end















GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO















CREATE          Procedure [dbo].[A_CallCenter_Office_Contragents_SetValue]
--Current Contragent
@@idContragent uniqueidentifier,
--Current FormControl DataField
@@idFormCurrent uniqueidentifier,
@@idFormListCurrent uniqueidentifier,
@@idFormControlCurrent uniqueidentifier,
--Binded Form Control DataField
@@idFormBinded uniqueidentifier,
@@idFormListBinded uniqueidentifier,
@@idFormControlBinded uniqueidentifier,

--Values
@@ValueInt int = 0,
@@ValueStr nvarchar(2000) = '',
@@ValueDate datetime = getdate,
@@IndexToValue int = 0,
--ColumnName for Current
@@ColumnName nvarchar(255)
as
--Consts
declare @cValueUsedLink nvarchar(50)
set @cValueUsedLink = 'ValueLink'

--Vars
declare @idValue uniqueidentifier
declare @ColumnName nvarchar(255)
declare @SQL nvarchar(1000)

--Define Current List & Form
if( @@idFormBinded = '00000000-0000-0000-0000-000000000000')
  set @@idFormBinded = @@idFormCurrent
if( @@idFormListBinded = '00000000-0000-0000-0000-000000000000')
  set @@idFormListBinded = @@idFormListCurrent


--Check Table For Record Existing
if( not exists( 
		select ValueUsed 
		from A_Clients_ClientForms 
		Where idContragent = @@idContragent and idForm = @@idFormCurrent and idFormList = @@idFormListCurrent and idFormControl = @@idFormControlCurrent
  ) )
begin
	set @idValue = NEWID ( )
	insert 	A_Clients_ClientForms ( idValue, idForm, idFormList, idFormControl, idContragent, ValueUsed, idValueParent  ) 
		Values ( @idValue , @@idFormCurrent, @@idFormListCurrent, @@idFormControlCurrent, @@idContragent, 'ValueStr', @idValue  )
end


if( @@idFormControlCurrent = @@idFormControlBinded ) --Current FormControl
begin
	
	--Update Control DataField
	set @SQL = 'update A_Clients_ClientForms
	set @@ColumnName = ''@@Value'', ValueUsed = ''@@UsedColumnName''
	Where idContragent = ''@@idContragent'' and idForm = ''@@idFormCurrent'' and idFormList = ''@@idFormListCurrent'' and idFormControl = ''@@idFormControlCurrent'''
	set @SQL = replace( @SQL, '@@ColumnName', case 
							when @@IndexToValue = 2 then @@ColumnName + '2' 
							else @@ColumnName 
						  end  )
	set @SQL = replace( @SQL, '@@UsedColumnName', @@ColumnName )
	set @SQL = replace( @SQL, '@@Value', case @@IndexToValue
 						  when 0 then @@ValueStr 
						  when 1 then  cast( @@ValueDate as nvarchar(100) )
						  when 2 then  cast( @@ValueDate as nvarchar(100) )
						  when 3 then cast( @@ValueInt as nvarchar(100) )
						  else @@ValueStr 
					      end )
	set @SQL = replace( @SQL, '@@idContragent', @@idContragent )
	set @SQL = replace( @SQL, '@@idFormCurrent', @@idFormCurrent )
	set @SQL = replace( @SQL, '@@idFormListCurrent', @@idFormListCurrent )
	set @SQL = replace( @SQL, '@@idFormControlCurrent', @@idFormControlCurrent )
	exec sp_sqlexec @SQL


end

else -- Another Form Control (from DataBinding Info)
begin
	--Define link to another control (from databinding)
	declare @idValueParent uniqueidentifier
	declare @ValueUsed nvarchar(200)

	--Define Link To Parent
	select @idValue = idValue, @idValueParent = idValueParent, @ValueUsed = ValueUsed
	from A_Clients_ClientForms 
	Where idContragent = @@idContragent and idForm = @@idFormBinded and idFormList = @@idFormListBinded and idFormControl = @@idFormControlBinded	

	--Search for Target Value
	declare @idValueParentCurrent uniqueidentifier
	set @idValueParentCurrent = @idValueParent
	while ( @ValueUsed = @cValueUsedLink )
	begin		
		select @idValue = idValueParent, @ValueUsed = ValueUsed
		from A_Clients_ClientForms 
		Where idValue = @idValueParentCurrent
		set @idValueParentCurrent = @idValue
	end

	--Update Control Current DataField
	-- Save Link To Another Control (Parent)
	update A_Clients_ClientForms
	set ValueUsed = @cValueUsedLink, idValueParent = @idValue
	Where idContragent = @@idContragent and idForm = @@idFormCurrent and idFormList = @@idFormListCurrent and idFormControl = @@idFormControlCurrent

	--Define ColumnName of DataField of Another Control
	select @ColumnName = ValueUsed 
		from A_Clients_ClientForms 
		Where idValue = @idValue

	--Update Anoher Control DataField (by 
	set @SQL = 'update A_Clients_ClientForms
	set @@ColumnName = ''@@Value'', ValueUsed = ''@@UsedColumnName''
	where idValue = ''@@idValue'''
	set @SQL = replace( @SQL, '@@ColumnName', case 
							when @@IndexToValue = 2 then @ColumnName + '2' 
							else @ColumnName 
						  end  )
	set @SQL = replace( @SQL, '@@UsedColumnName', @@ColumnName )
	set @SQL = replace( @SQL, '@@Value', case @@IndexToValue
 						  when 0 then @@ValueStr 
						  when 1 then  cast( @@ValueDate as nvarchar(100) )
						  when 2 then  cast( @@ValueDate as nvarchar(100) )
						  when 3 then cast( @@ValueInt as nvarchar(100) )
						  else @@ValueStr 
					      end )
	set @SQL = replace( @SQL, '@@idValue', @idValue )
	exec sp_sqlexec @SQL

end









GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_SaveCommonForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_SaveCommonForScript]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

CREATE  Procedure [dbo].[A_CallCenter_Office_Contragents_SaveCommonForScript]
as
begin
 --Create Contragent from script oblect CServerHObjectUserState
 declare @idContragent uniqueidentifier

 while 1 = 1 begin
	 set @idContragent = newid()
	 if( exists( select idContragent from A_Contragent where idContragent = @idContragent ) )
		continue

	insert A_Contragent ( idContragent, Code, [Name] )
	values( @idContragent, '', '' ) 
	select scope_identity()
	break
 end

	
end






GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_CallCenter_Office_Contragents_DeleteForScript]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_CallCenter_Office_Contragents_DeleteForScript]
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO










CREATE      Procedure [dbo].[A_CallCenter_Office_Contragents_DeleteForScript]
@@idContragent int
as
begin	
	delete A_Contragent
	where idContragent_int = @@idContragent
end









GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

