if exists ( Select * FROM sysobjects Where id = object_id ( 'dbo.A_SchedulerTask_GetByUser' ) )
     Drop Procedure dbo.A_SchedulerTask_GetByUser
GO

Create Procedure dbo.A_SchedulerTask_GetByUser
     @iduser uniqueidentifier
as
begin

     --     
     Declare @controlled table ( Id uniqueidentifier )

     --        
     Insert into @controlled ( Id ) Values ( @iduser )
     Insert into @controlled ( Id )
          Select UserB 
          From A_UserControls
          Where (UserA = @iduser) AND (UserB != @iduser)

     --   
     Select t.Id, t.UDirector, t.UExecuter, t.Start, t.Stop, t.MyStart, t.MyStop, t.Title, t.Comment, t.Priority, t.DoneProcess, t.Done, t.Canceled
     From dbo.A_Scheduler_Tasks t
          Inner join @controlled c on t.UExecuter = c.Id

end
GO