
if exists ( select * From sysobjects where id=object_id('dbo.A_EmergencyDirections') )
	Drop table dbo.A_EmergencyDirections
GO

Create table dbo.A_EmergencyDirections 
(
	OrderIdx int not null,
	ObjectId uniqueidentifier not null
)
GO

if exists ( select * From sysobjects where id=object_id('dbo.A_EmergencyDirections_GetAll') )
	Drop procedure dbo.A_EmergencyDirections_GetAll
GO

Create procedure dbo.A_EmergencyDirections_GetAll
as
Begin
	Select OrderIdx, ObjectId
	From A_EmergencyDirections
	Order By OrderIdx
End
GO

if exists ( select * From sysobjects where id=object_id('dbo.A_EmergencyDirections_Clear') )
	Drop procedure dbo.A_EmergencyDirections_Clear
GO

Create procedure dbo.A_EmergencyDirections_Clear
as
Begin
	Delete 
	From A_EmergencyDirections
End
GO

if exists ( select * From sysobjects where id=object_id('dbo.A_EmergencyDirections_Save') )
	Drop procedure dbo.A_EmergencyDirections_Save
GO

Create procedure dbo.A_EmergencyDirections_Save
	@idx int,
	@objectid uniqueidentifier
as
Begin
	Insert into A_EmergencyDirections ( OrderIdx, ObjectId )
	Values ( @idx, @objectid )
End
GO