﻿if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_Save' ))
	Drop procedure dbo.A_UserNotifyLog_Save
GO

Create Procedure [dbo].[A_UserNotifyLog_Save]
	@id		uniqueidentifier = NULL,
	@userid		uniqueidentifier,
	@datetime	datetime,
	@logtype	int,
	@sendertext	nvarchar(500),
	@text		nvarchar(4000),
	@wasshown	int,
	@oneonscreen	bit = NULL,
	@oneonscreenid	nvarchar(200) = NULL
as
begin
	if ( @id is NULL )
		set @id = NewId ()

	if exists ( Select id From A_Users Where Id = @userid )		
	    Insert into A_User_NotifyLog
		( Id, IdUser, NotifyDateTime, LogType, TextSender, TextInfo, WasShown, OneOnScreen, OneOnScreenId )
	    Values
		( @id, @userid, @datetime, @logtype, @sendertext, @text, @wasshown, @oneonscreen, @oneonscreenid )
end
GO
