﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Stat_RecordedDirectories_GetInterval' ))
	Drop procedure dbo.A_Stat_RecordedDirectories_GetInterval
GO

Create procedure dbo.A_Stat_RecordedDirectories_GetInterval
	@dtfrom datetime = null
as
begin	
 	Select 
		IsNull ( Min (id) - 1, 0 ) as minid,
		IsNull ( Max (id), 0 ) as maxid
	From A_Stat_RecordDirectories
	Where DTStart > @dtfrom
end
GO 

