﻿if exists ( Select * from sysobjects where id = object_id('dbo.WO_Dashboards_Dashboard_Set'))
	Drop procedure dbo.WO_Dashboards_Dashboard_Set
GO

Create PROCEDURE [dbo].[WO_Dashboards_Dashboard_Set]
	@authorizeduserid	uniqueidentifier,
	@dashboardid	uniqueidentifier,
	@ispublic	bit,
	@password	nvarchar(4000)
as
begin
	
	declare	@can bit
	exec A_Dashboards_CheckCanEdit @authorizeduserid = @authorizeduserid, @dashboardid = @dashboardid, @canedit = @can OUTPUT
	if ((select @can) = 1)
		begin
			
			-- Обновляет название
			Update [dbo].[WO_Dashboards_Dashboards]
			Set	IsPublic = @ispublic,
				[Password] = case when @password = '' then null else @password end
			Where Id = @dashboardid
			
		end
	
	else
		begin
			RAISERROR ('Access error', 16, 1)
		end
end

GO