
Update A_Stat_Connections_1x1
Set AUserId = 'AB000000-0000-0000-0000-000000000000'
Where ALineId = '00000000-0000-0000-0000-000000000000'

GO



Update A_Stat_Connections_1x1
Set BUserId = 'AB000000-0000-0000-0000-000000000000'
Where BLineId = '00000000-0000-0000-0000-000000000000'


GO







ALTER        procedure [dbo].[C_CallCenter_GetTaskJournal]
	@dstart 	datetime,
	@dstop 		datetime,
	@tstart 	datetime,
	@tstop 		datetime,
	@taskid 	uniqueidentifier,
	@number 	nvarchar ( 50 ),
	@operatorid	uniqueidentifier,
	@showefforts	int


As
Begin
-------------------------------------------------------------------------------------------------
/*
declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare	@taskid 	uniqueidentifier
declare	@number 	nvarchar ( 50 )
declare	@operatorid	uniqueidentifier
declare	@showefforts	int


set dateformat dmy
set @dstart = '2006/05/01'
set @dstop = '2006/06/15'
set @tstart = '01:11:00'
set @tstop = '22:29:00'
select @taskid = id from A_TaskManager_Tasks where name like ''
set @number = ''
set @operatorid ='00000000-0000-0000-0000-000000000000'
set @showefforts = 1

@dstart = ' 16 2006 12:00AM', @dstop = ' 16 2006 11:59PM', @tstart = N'8:00', @tstop = N'20:00', @taskid = 'A6EE1A23-00A7-494E-9A9F-78B3C2AF8FCA', @number = N'', @operatorid = '00000000-0000-0000-0000-000000000000', @showefforts = 0

*/



declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )



declare @te table ( EffortId uniqueidentifier, IdChain uniqueidentifier, Number nvarchar ( 50 ), CallTime DateTime, Result int, Info nvarchar ( 500 ) )

Insert into @te

	Select ste.Id, ConnectionId, EffortCalledNumber, EffortDateTime, EffortResult, EffortInfo
	From A_TaskManager_SubTaskEfforts ste
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id
		Where TaskId = @taskid
			and EffortDateTime > @dstart 
			and EffortDateTime < @dstop
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) >= @tstartfloat
			and Convert ( float, EffortDateTime ) - FLOOR ( Convert ( float, EffortDateTime ) ) < @tstopfloat
			and EffortCalledNumber like '%' + @number + '%'

	union all

	Select tic.Id, ConnectionChainId, Number, CallTimeStart, CallResult, CallInfo
	From A_TaskManager_Task_IncomingCalls tic
		Where TaskId = @taskid
			and CallTimeStart > @dstart 
			and CallTimeStart < @dstop
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) >= @tstartfloat
			and Convert ( float, CallTimeStart ) - FLOOR ( Convert ( float, CallTimeStart ) ) < @tstopfloat
			and Number like '%' + @number + '%'


if ( @showefforts <= 0 )
	Delete 
	From @te 
	Where IdChain = '00000000-0000-0000-0000-000000000000'


declare @type int
Select @type = Type FROM A_TaskManager_Tasks Where Id = @taskid


declare @u table ( Id uniqueidentifier, Name nvarchar ( 100 ) )
	Insert into @u
		Select Id, Name 
		From A_Users
	Insert into @u 
		(Id, Name)
		Values
		('AB000000-0000-0000-0000-000000000000', 'IVR')

	
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsRecorded, ARecFile, BRecFile
	From
	(
		Select te.Number, isnull ( ua.Name, isnull ( ub.Name, '' ) )as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te			
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and te.CallTime <= sc.TimeStart
			left join @u ua on sc.AUserId = ua.Id
			left join @u ub on sc.BUserId = ub.Id
		Where sc.AUserId = @operatorid
			or sc.BUserId = @operatorid 
			or @operatorid = '00000000-0000-0000-0000-000000000000'
	)a
	Order By CallTime


/*
if ( @type < 4 )
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsNull ( IsRecorded, 0 ) as IsRecorded, IsNull ( ARecFile, '' ) as ARecFile, IsNull ( BRecFile, '' ) as BRecFile
	From
	(
		Select te.Number ,'IVR' as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain
	)a
	Order By CallTime
else
	Select Number, FullName, CallTime, Result, tStop - tStart as Length, Info, IsRecorded, ARecFile, BRecFile
	From
	(
		Select te.Number ,u.Name as FullName, CallTime, te.Result, te.Info, IsNull ( sc.TimeAnswer, 0 ) tStart, IsNull ( sc.TimeStop, 0 ) tStop, sc.IsRecorded, sc.ARecFile, sc.BRecFile
		From @te te
			inner join A_TaskManager_UserInTask ut on ut.EffortId = te.EffortId
			inner join A_Users u on ut.UserId = u.Id
			left join A_Stat_Connections_1x1 sc on te.IdChain = sc.IdChain and ( AUserId = ut.UserId or BUserId = ut.UserId )
		Where sc.AUserId = @operatorid
			or sc.BUserId = @operatorid 
			or @operatorid = '00000000-0000-0000-0000-000000000000'
	)a
	Order By CallTime
*/




end



GO






ALTER    procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - , 2 - , 3 - , 0 - 
	@type 		int, --1 - , 2 - , 3 - , 0 - 
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier
as
begin

/*
	declare @media 	int --1 - , 2 - , 3 - , 0 - 
	declare @type 	int --1 - , 2 - , 3 - , 0 - 
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'

*/
	Declare @ids table ( id uniqueidentifier )	

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc
			Where TimeStart > @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
		
	Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, TimeStart DateTime, Length DateTime, Number nvarchar ( 50 ), AbonentName nvarchar ( 100 ), IsRecorded int, ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), AUserId uniqueidentifier, BUserId uniqueidentifier, ALineId uniqueidentifier, BLineId uniqueidentifier, AOutNumber nvarchar ( 50 ), BOutNumber nvarchar ( 50 ), AStr nvarchar ( 100 ), BStr nvarchar ( 100 ) )
	Insert into @output
		Select sc.Id, sc.IdChain, null, 0, sc.TimeStart, sc.TimeStop - sc.TimeAnswer as Length, '', '', IsRecorded, ARecFile, BRecFile, AUserId, BUserId, ALineId, BLineId, AOutNumber, BOutNumber, AStr, BStr
		From A_Stat_Connections_1x1 sc
			inner join @ids ids on sc.Id = ids.id

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where o.Number = cc.Content and cc.IdClient = c.Id

	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = '' and o.Number = ''

	Select Id, Media, Type, TimeStart, Length, Number, AbonentName, IsRecorded--, ARecFile, BRecFile
	From @output
	Where Media = @media or @media = 0
	Order By TimeStart Desc

end




GO






ALTER   Procedure [dbo].C_CallCenter_GetOperatorJournal
	
	@dstart 	datetime,
 	@dstop 		datetime,
 	@tstart 	datetime,
 	@tstop 		datetime,
 	@id 		uniqueidentifier,
 	@isgroup  	int,
 	@number 	nvarchar ( 50 ),
	@taskid 	uniqueidentifier,
 	@calltype 	int
As

Begin

/*
---  

declare @dstart datetime
declare @dstop 	datetime
declare @tstart datetime
declare @tstop 	datetime
declare @id uniqueidentifier
declare @isgroup  int
declare @number nvarchar ( 50 )
declare @taskid uniqueidentifier
declare @calltype int

set dateformat dmy
set @dstart = '16.12.2006'
set @dstop = '17.12.2006'
set @tstart = '8:11:00'
set @tstop = '15:20:00'
select @id = id from A_Users where login like 'Peter'
set @isgroup = 0
set @calltype = -1
set @taskid = '00000000-0000-0000-0000-000000000000'
set @number = ''

*/





declare @tstartfloat float 
declare @tstopfloat float
set @tstartfloat = Convert ( float, @tstart )
set @tstopfloat  = Convert ( float, @tstop )
set @tstartfloat = @tstartfloat - FLOOR ( @tstartfloat )
set @tstopfloat = @tstopfloat - FLOOR ( @tstopfloat )


--  
declare @users table ( userid uniqueidentifier, username nvarchar ( 50 ) )

if ( @isgroup > 0 )
	insert into @users
		Select go.idoperator, u.Name
		From C_Groups g 
			inner join C_GroupOperators go on g.Id = go.idgroup		
			inner join A_Users u on u.Id = go.idoperator
		Where g.Id = @id
else
begin
	declare @name nvarchar ( 50 )
	Select @name = Name from A_Users where Id = @id
	insert into @users ( userid, username ) values ( @id, @name )
end



--   (     )
declare @tasks table ( id uniqueidentifier, status int, outputtask int, name nvarchar ( 500 ) )
if ( @taskid = '00000000-0000-0000-0000-000000000000' )
	insert into @tasks
		Select t.Id, t.active + t.done * 2, t.IsOutputTask, t.Name
		FROM A_TaskManager_Tasks t
else
	insert into @tasks
		Select t.Id, t.active + t.done * 2, t.IsOutputTask, t.Name
		FROM A_TaskManager_Tasks t
		Where id = @taskid




-- -   StatConnections
declare @connections table ( id uniqueidentifier, idchain uniqueidentifier, AUserId uniqueidentifier, BUserId uniqueidentifier, TimeStart datetime, TimeStop datetime, AOutNumber nvarchar ( 50 ), BOutNumber nvarchar ( 50 ), IsRecorded int, ARecFile nvarchar ( 50 ), BRecFile nvarchar ( 50 ), Astr nvarchar ( 100 ), BStr nvarchar ( 100 ) )
if ( @number = '' )
	insert into @connections
		Select Id, IdChain, AUserId, BUserId, TimeStart, TimeStop, AOutNumber, BOutNumber, IsRecorded, ARecFile, BRecFile, Astr, Bstr
		From A_Stat_Connections_1x1
		Where TimeStop > @dstart and TimeStart < @dstop
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
			and AUserId != 'AB000000-0000-0000-0000-000000000000' and BUserId != 'AB000000-0000-0000-0000-000000000000'
else
	insert into @connections
		Select Id, IdChain, AUserId, BUserId, TimeStart, TimeStop, AOutNumber, BOutNumber, IsRecorded, ARecFile, BRecFile, Astr, BStr
		From A_Stat_Connections_1x1
		Where TimeStop > @dstart and TimeStart < @dstop
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) >= @tstartfloat
			and Convert ( float, TimeStart ) - FLOOR ( Convert ( float, TimeStart ) ) < @tstopfloat
			and AUserId != 'AB000000-0000-0000-0000-000000000000' and BUserId != 'AB000000-0000-0000-0000-000000000000'
			and ( AOutNumber like '%' + @number + '%' Or BOutNumber like '%' + @number + '%' )
	



--  chain   
declare @taskchains table ( idtask uniqueidentifier, idchain uniqueidentifier )
insert into @taskchains
	Select t.Id, ste.ConnectionId
	From A_TaskManager_SubTaskEfforts ste 
		inner join A_TaskManager_SubTasks st on ste.SubTaskId = st.Id
		inner join @tasks t on st.TaskId = t.Id
	Where EffortDateTime > @dstart and EffortDateTime < @dstop 
	
	Union 
	
	Select t.Id, ic.ConnectionChainId
	From A_Taskmanager_Task_IncomingCalls ic 
		inner join @tasks t on ic.TaskId = t.Id
	Where CallTimeStop > @dstart and CallTimeStart < @dstop


/*
declare @subtaskparams table ( )
insert into @subtaskparams
	Select 
	From A_TaskManager_Task_IncomingCalls ic
		TaskId, TaskStart
*/
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
--  
declare @OutPut table ( idchain uniqueidentifier, type int, userid uniqueidentifier, username nvarchar ( 50 ), number nvarchar ( 50 ), taskid uniqueidentifier, taskname nvarchar ( 500 ), timestart datetime, length float, effort nvarchar ( 100 ), isrecorded int, arecord nvarchar ( 100 ), brecord nvarchar ( 100 ) )
-------------------------

if ( @calltype = -1 or @calltype = 0 )
	insert into @OutPut
		Select idchain, 0, u.UserId, u.UserName, case when sc.BOutNumber != '' then sc.BOutNumber else sc.BStr end, null, null, TimeStart, CONVERT ( float, TimeStop - TimeStart ), null, IsRecorded, ARecFile, BRecFile
		From @connections sc 
			inner join @users u on u.userid = sc.AUserId

if ( @calltype = -1 or @calltype = 1 )
	insert into @OutPut	
		Select idchain, 1, u.UserId, u.UserName, case when sc.AOutNumber != '' then sc.AOutNumber else sc.AStr end, null, null, TimeStart, CONVERT ( float, TimeStop - TimeStart ), null, IsRecorded, ARecFile, BRecFile
		From @connections sc
			inner join @users u on u.userid = sc.BUserId


Update @OutPut 
Set taskid = t.id, taskname = t.Name
From @Output o, @tasks t, @taskchains tc
Where o.idchain = tc.idchain and t.id = tc.idtask


if ( @calltype = 2 )
	Delete From @OutPut
	Where taskid is null


if ( @taskid != '00000000-0000-0000-0000-000000000000' )
	Delete from @OutPut 
	Where taskid != @taskid or taskid is null


Select * FROM @OutPut
Order By TimeStart

End



GO
