Alter table A_Redirect_Abonents Add Type int
GO

Update A_Redirect_Abonents
Set Type = case when number != '' then 0 else 1 end

GO

CREATE  procedure [dbo].[A_Clients_Check_ClientInGroup_ByIds]
	@idclient 	uniqueidentifier,
	@idgroup	nvarchar ( 255 ),
	@result		bit	OUTPUT
as
begin
	Set @result = 0

	Select [Id]
	From A_Clients_Groups
	Where IdClient = @idclient
		And IdGroup = @idgroup
	
	if ( @@rowcount > 0 )
		Set @result = 1
end

GO