
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_GetAllUnShown_ForUser' ) )
Drop procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
GO

CREATE Procedure [dbo].[A_UserNotifyLog_GetAllUnShown_ForUser]
	@id 	uniqueidentifier
as
begin
	BEGIN TRAN

	Select Top 15 * 
	FROM A_User_NotifyLog 
	where IDuser = @id and WasShown = 0
	Order by NotifyDateTime Desc

	Update A_User_NotifyLog 
		Set WasShown = 1 
		Where IdUser = @id and WasShown = 0

	COMMIT
end

GO

