
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_TaskOut_UpdateResult_Effort]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_Effort]
GO


Create Procedure dbo.A_TaskManager_TaskOut_UpdateResult_Effort
	@id 			uniqueidentifier,
	@idinlist		int,
	@idtask			uniqueidentifier,
	@number			nvarchar ( 20 ),
	@edatetime		datetime,
	@eresult		int,
	@einfo			nvarchar(500),
	@idchain		uniqueidentifier
as

begin
	-- 
	Insert Into A_TaskManager_SubTaskEfforts
		( Id, IdInList, TaskId, Number, EDateTime, EResult, EInfo, ConnectionChainId )
	Values	
		( @id, @idinlist, @idtask, @number, @edatetime, @eresult, @einfo, @idchain )

	--      	
	Update A_Stat_Connections_1x1 with ( tablock )
	Set FromCC = 1 Where IdChain = @idchain
end

GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_Task_AddIncomingCall]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_Task_AddIncomingCall]
GO


Create Procedure dbo.A_TaskManager_Task_AddIncomingCall

	@id				uniqueidentifier,
	@taskid				uniqueidentifier,
	@number				nvarchar ( 50 ),
	@timestart			datetime,
	@timestop			datetime,
	@callresult			int,
	@callresultinfo			nvarchar ( 500 ),
	@connectionchainid		uniqueidentifier
as

begin
	
	if Exists ( select Id from A_TaskManager_Tasks where id = @taskid )
	begin
		--   
		Insert Into A_TaskManager_Task_IncomingCalls
			( Id, TaskId, Number, CallTimeStart, CallTimeStop, CallResult, CallInfo, ConnectionChainId )
		Values 
			( @id, @taskid, @number, @timestart, @timestop, @callresult, @callresultinfo, @connectionchainid )

		--      
		Update A_Stat_Connections_1x1 with ( tablock )
		Set FromCC = 1 Where IdChain = @connectionchainid
	end
end

GO