if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Service_StatRemove' ) )
	Drop procedure dbo.A_Service_StatRemove
GO


Create procedure dbo.A_Service_StatRemove	
	@pbxdrop bit,
	@pbxdropfiles bit,
	@pbxfromdate DateTime,
	@ccdrop bit,
	@ccdropfiles bit,
	@ccfromdate DateTime,
	@dropped int OUTPUT
as
begin

--
/*
declare @pbxdrop bit
declare @pbxdropfiles bit
declare @pbxfromdate DateTime
declare @ccdrop bit
declare @ccdropfiles bit
declare @ccfromdate DateTime
declare @dropped int

set @pbxdrop = 0
set @pbxdropfiles = 1
set @pbxfromdate = '05.05.2007'
set @ccdrop = 0
set @ccdropfiles = 0
set @ccfromdate = '01.04.2007'
*/
--
	set @dropped = 0

	--       
	declare @a table ( IdRecDir int, ALineNum nvarchar ( 5 ), BLineNum nvarchar ( 5 ), TimeStart DateTime, FromCC bit )

	if ( @pbxdropfiles = 1 and @ccdropfiles = 1 )	
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1
			Where (( TimeStart < @pbxfromdate and FromCC = 0 )
				Or ( TimeStart < @ccfromdate and FromCC = 1 )) 
				And IsRecorded = 1
			Order By TimeStart

	else if ( @pbxdropfiles = 1 )
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1
			Where ( TimeStart < @pbxfromdate and FromCC = 0 )
				And IsRecorded = 1
			Order By TimeStart

	else if ( @ccdropfiles = 1 )
		Insert into @a
			Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			From A_Stat_Connections_1x1
			Where ( TimeStart < @ccfromdate and FromCC = 1 )
				And IsRecorded = 1
			Order By TimeStart


	--   
	if ( @pbxdrop = 1 and @ccdrop = 1 )
	begin
		Delete
		From A_Stat_Connections_1x1
		Where ( TimeStart < @pbxfromdate and FromCC = 0 )
			Or ( TimeStart < @ccfromdate and FromCC = 1 )

		Set @dropped = @@rowcount
	end

	else if ( @pbxdrop = 1 )
	begin
		Delete
		From A_Stat_Connections_1x1			
		Where ( TimeStart < @pbxfromdate and FromCC = 0 )

		Set @dropped = @@rowcount
	end

	else if ( @ccdrop = 1 )
	begin
		Delete
		From A_Stat_Connections_1x1
		Where ( TimeStart < @ccfromdate and FromCC = 1 )

		Set @dropped = @@rowcount
	end


	--  
	Select * FROM @a	
end
GO



