if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardUserResults' ) )
	Drop table dbo.A_TaskManager_CardUserResults
GO

Create table dbo.A_TaskManager_CardUserResults
( Id int primary key not null,  
  Name nvarchar ( 100 ) not null,
  Success bit not null,
  IsDefault bit not null
)
GO

if exists ( Select * FROM sysobjects where Id = Object_Id ( 'dbo.A_TaskManager_CardUserResults_Get' ) )
	Drop procedure dbo.A_TaskManager_CardUserResults_Get
GO

Create procedure dbo.A_TaskManager_CardUserResults_Get
as
begin
	Select Id, Success, IsDefault, Name
	From A_TaskManager_CardUserResults
	Order by Success, IsDefault Desc, Id
end
GO
