if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Workplace_Get_By_10_Addresses' ) )
	drop procedure dbo.A_Workplace_Get_By_10_Addresses
GO


Create PROCEDURE [dbo].[A_Workplace_Get_By_10_Addresses] 
	@address0	nvarchar (50) = '',
	@address1 	nvarchar (50) = '',
	@address2 	nvarchar (50) = '',
	@address3 	nvarchar (50) = '',
	@address4 	nvarchar (50) = '',
	@address5 	nvarchar (50) = '',
	@address6 	nvarchar (50) = '',
	@address7 	nvarchar (50) = '',
	@address8 	nvarchar (50) = '',
	@address9 	nvarchar (50) = '',
	@address10 	nvarchar (50) = '',
	@type 		int OUTPUT,
	@parentwpt 	uniqueidentifier OUTPUT, 
	@id 		uniqueidentifier OUTPUT, 
	@name 		nvarchar(50) OUTPUT, 
	@address 	nvarchar(50) OUTPUT,
	@haslogic 	bit OUTPUT, 
	@hasfastengine 	bit OUTPUT, 
	@hasdatabase 	bit OUTPUT, 
	@hasextlines 	bit OUTPUT, 
	@lineid 	uniqueidentifier OUTPUT,
	@hasGSM 	bit OUTPUT, 
	@hasintlines 	bit OUTPUT,
	@retvalue 	int OUTPUT
AS
BEGIN
	Declare @cnt int
	Set @retvalue=50102
	Declare @pass nvarchar(50)
	
	Select @cnt=count(*) 
	From A_WorkPlaces 
	Where ((Address like @address0)
		or (Address like @address1)
		or (Address like @address2)
		or (Address like @address3)
		or (Address like @address4)
		or (Address like @address5)
		or (Address like @address6)
		or (Address like @address7)
		or (Address like @address8)
		or (Address like @address9)
		or (Address like @address10)) 
	       and (hasdatabase=0) and not (Address like '')

	if ( @cnt > 0 )
	begin
		Select @name = name, 
			@address = address, 
			@type=type, 
			@parentwpt=Parentid,@id=[ID], 
			@haslogic=haslogic, 
			@hasfastengine=hasfastengine, 
			@hasdatabase=hasdatabase, 
			@hasextlines=hasextlines,
			@hasGSM=hasGSM, 
			@hasintlines=hasintlines, 
			@lineid=lineid
		From A_WorkPlaces
		Where ((Address like @address0)
			or (Address like @address1)
			or (Address like @address2)
			or (Address like @address3)
			or (Address like @address4)
			or (Address like @address5)
			or (Address like @address6)
			or (Address like @address7)
			or (Address like @address8)
			or (Address like @address9)
			or (Address like @address10)) 
		       and (hasdatabase=0) and not (Address like '')
	
		Set @retvalue=0
	end
	else
	begin
		Set @retvalue=50102
	end
end
GO
