if exists ( Select * From sysobjects where id = object_id ( 'dbo.Report1_2' ))
	drop procedure dbo.Report1_2
GO

/*
1.2	       call-  
 : 
:
	   
	   
	   
	   
	  (30 , 1 , 3 , 1 , 1 , 1 )
	  (: 1  )
  (  )
 
	  (: 1.  1   2. 2)
	    
	      
	   - 
	   ( )
	    HOLD ( Flash   )
	    HOLD
	    HOLD
	   
	   - 
	   
	   (         -)
	    
	   
*/

Create procedure dbo.Report1_2
	@d1 datetime,
	@d2 datetime,
	@t1 datetime,
	@t2 datetime,
	@intervalmin int = 30,
	@tasks nvarchar ( 100 ) = '',
	@operator uniqueidentifier
as
begin

	set dateformat dmy

/*
	Declare @d1 datetime, @d2 datetime, @t1 datetime, @t2 datetime, @operator uniqueidentifier
	Select @d1 = '02.04.2008 0:00', @d2 = GetDate(), @t1 = '8:00', @t2 = '20:00'
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#tasks' ) )
		drop table #tasks
	Create table #tasks  ( id uniqueidentifier )
	Insert into #tasks
		Values ( 'CB3400A0-AB2B-46C2-B562-AC586AA5E444' )
		--Select Id from A_Taskmanager_Tasks
	Select @operator = id from A_Users where login like 'Peter'
	Declare @intervalmin int 
	set @intervalmin = 30
*/

	if ( @intervalmin is null )
		set @intervalmin = 1440

	--  
	declare @dstart datetime, @dstop datetime
	declare @tstart datetime, @tstop datetime
	set @dstart = Cast ( Floor ( cast ( @d1 as float ) ) as DateTime )
	set @dstop = Cast ( Floor ( cast ( @d2 as float ) + 1 ) as DateTime )
	set @tstart = Cast ( Cast ( @t1 as float ) - Floor ( cast ( @t1 as float ) ) as DateTime )
	set @tstop = Cast ( Cast ( @t2 as float ) - Floor ( cast ( @t2 as float ) ) as DateTime )

------------------------------------------------------------------------------------------------------
--   
	Declare @intervals table ( DTStart DateTime, DTStop DateTime, DStart DateTime, DStop DateTime, TStart DateTime, TStop DateTime )
	Declare @dt1 datetime, @dt2 datetime
	Declare @curday datetime, @curtime datetime
	Select @curday = @dstart, @curtime = @tstart
	while ( @curday < @dstop )
	   begin
		Set @dt1 = @curday + @curtime
		Set @dt2 = DateAdd ( mi, @intervalmin, @dt1 )

		Insert into @intervals
		Values ( @dt1, @dt2,
			Cast ( Floor ( cast ( @dt1 as float ) ) as DateTime ),
			Cast ( Floor ( cast ( @dt2 as float ) ) as DateTime ),
			Cast ( Cast ( @dt1 as float ) - Floor ( cast ( @dt1 as float ) ) as DateTime ),
			Cast ( Cast ( @dt2 as float ) - Floor ( cast ( @dt2 as float ) ) as DateTime ) )

		Set @curtime = DateAdd ( mi, @intervalmin, @curtime )
		if ( @curtime >= @tstop )
		begin
			set @curday = DateAdd ( d, 1, @curday )
			set @curtime = @tstart
		end

		if ( @curday >= @dstop )
			break;
	   end

------------------------------------------------------------------------------------------------------
--   
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
		drop table #t
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t2' ) )
		drop table #t2
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t3' ) )
		drop table #t3
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t4' ) )
		drop table #t4

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp0' ) )
		drop table #tmp0
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp1' ) )
		drop table #tmp1
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp2' ) )
		drop table #tmp2
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp3' ) )
		drop table #tmp3
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp4' ) )
		drop table #tmp4
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp5' ) )
		drop table #tmp5
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp6' ) )
		drop table #tmp6
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp7' ) )
		drop table #tmp7
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp8' ) )
		drop table #tmp8
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp9' ) )
		drop table #tmp9
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp10' ) )
		drop table #tmp10
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp11' ) )
		drop table #tmp11
	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tmp12' ) )
		drop table #tmp12



	--      
	Select * Into #t
	From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec
	Where DateStart between @dstart and @dstop
		and TimeStart between @tstart and @tstop

	Select ec.* Into #t2
	From #t ec
		Inner join #tasks t on ec.IdTask = t.Id
	Where ec.IdOperator = @operator

	Select os.* Into #t3
	From oktell_cc_temp.dbo.A_Cube_CC_OperatorStates os		
		Inner join #tasks t on os.IdTask = t.Id
	Where DateStart between @dstart and @dstop
		and TimeStart between @tstart and @tstop
		and os.IdOperator = @operator


	--   
	Declare @output table ( DTStart DateTime, DTStop DateTime, TotalCntIncoming int, AvgTalk1 int, AvgTalk2 int, AvgPost int, AvgBusinessPerc float, SumTalk1 int, SumTalk2 int, SumPost int, SumLunch int, SumFree int, SumInCC int )

	Insert Into @output ( DTStart, DTStop )
	Select DTStart, DTStop 
	From @intervals

------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------

--   .     
	Select i.DTStart, i.DTStop, Count ( * ) as TotalIncoming Into #tmp0
	From (
		Select IdChain, Min ( DateTimeStart ) DateTimeStart FROM #t2 ec			
		Where ec.IsOutput = 0
		Group by IdChain
		) ec
		Inner join @intervals i on ec.DateTimeStart between i.DTStart and i.DTStop
	Group By i.DTStart, i.DTStop
	Order By i.DTStart


	Update o
		Set TotalCntIncoming = tmp.TotalIncoming
	From @output o, #tmp0 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp0


------------------------------------------------------------------------------------------------------
--      
-- (    (timestart-timestop))
	Select i.DTStart, i.DTStop, Avg ( LenTalk1 ) LenTalk1 into #tmp2
	From (
		Select DTStart, DTStop, IdChain, IdEffort, cast ( DTStop - DTStart as float ) * 86400 as LenTalk1
		From (
			Select IdChain, IdEffort, Min ( DateTimeStart ) DTStart, Max ( DateTimeStop ) DTStop 
			From #t2 ec
			Group By IdChain, IdEffort
			)a 
		) b
			Inner join @intervals i on b.DTStart between i.DTStart and i.DTStop 
	Group by i.DTStart, i.DTStop


	Update o
		Set AvgTalk1 = tmp.LenTalk1
	From @output o, #tmp2 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp2

------------------------------------------------------------------------------------------------------
--      
-- (    (timeanswer-timestop))
	Select i.DTStart, i.DTStop, Avg ( LenTime ) LenTalk2 into #tmp3
	From (
		Select IdChain, IdEffort, Min ( DateTimeStart ) DTStart, Sum ( LenTime ) LenTime
		From #t2 ec
		Group By IdChain, IdEffort
		)a 
			Inner join @intervals i on a.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
		Set AvgTalk2 = tmp.LenTalk2
	From @output o, #tmp3 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp3

------------------------------------------------------------------------------------------------------
--    
	Select i.DTStart, i.DTStop, Sum ( LenTime ) LenTime into #tmp4
	From #t3 os
		Inner join @intervals i on os.DateTimeStart between i.DTStart and i.DTStop 
	Where State = 7
	Group By i.DTStart, i.DTStop

	Update o
		Set AvgPost = tmp.LenTime
	From @output o, #tmp4 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp4

------------------------------------------------------------------------------------------------------
--   
	Select DTStart, DTStop, Sum ( LenTime ) * 100 / cast ( DTStop - DTStart as float ) as Business into #tmp5
	From (
		Select DTStart, DTStop, cast ( Stop - Start as float ) as LenTime
		From (
			Select i.DTStart, i.DTStop, 
				case when ( os.DateTimeStart < i.DTStart ) then i.DTStart else os.DateTimeStart end as Start, 
				case when ( os.DateTimeStop > i.DTStop ) then i.DTStop else os.DateTimeStop end as Stop
			From #t3 os
				Inner join @intervals i on ( os.DateTimeStart between i.DTStart and i.DTStop ) or ( os.DateTimeStop between i.DTStart and i.DTStop )
			Where State < 8
		) a
	) b
	Group by DTStart, DTStop

	Update o
		Set AvgBusinessPerc = tmp.Business
	From @output o, #tmp5 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp5

------------------------------------------------------------------------------------------------------
--     
-- (    (timestart-timestop))
	Select i.DTStart, i.DTStop, Sum ( LenTalk1 ) LenTalk1 into #tmp6
	From (
		Select DTStart, DTStop, IdChain, IdEffort, cast ( DTStop - DTStart as float ) * 86400 as LenTalk1
		From (
			Select IdChain, IdEffort, Min ( DateTimeStart ) DTStart, Max ( DateTimeStop ) DTStop 
			From #t2 ec
			Group By IdChain, IdEffort
			)a 
		) b
			Inner join @intervals i on b.DTStart between i.DTStart and i.DTStop 
	Group by i.DTStart, i.DTStop


	Update o
		Set SumTalk1 = tmp.LenTalk1
	From @output o, #tmp6 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp6

------------------------------------------------------------------------------------------------------
--     
-- ( timeanswer-timestop)
	Select i.DTStart, i.DTStop, Sum ( LenTime ) LenTalk2 into #tmp7
	From (
		Select IdChain, IdEffort, Min ( DateTimeStart ) DTStart, Sum ( LenTime ) LenTime
		From #t2 ec
		Group By IdChain, IdEffort
		)a 
			Inner join @intervals i on a.DTStart between i.DTStart and i.DTStop 
	Group By i.DTStart, i.DTStop

	Update o
		Set SumTalk2 = tmp.LenTalk2
	From @output o, #tmp7 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp7

------------------------------------------------------------------------------------------------------
--    
	Select i.DTStart, i.DTStop, Sum ( LenTime ) LenTime into #tmp8
	From #t3 os
		Inner join @intervals i on os.DateTimeStart between i.DTStart and i.DTStop 
	Where State = 7
	Group By i.DTStart, i.DTStop

	Update o
		Set SumPost = tmp.LenTime
	From @output o, #tmp8 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp8


------------------------------------------------------------------------------------------------------
--   
	Select DTStart, DTStop, Sum ( LenTime ) LenTime into #tmp9
	From (
		Select DTStart, DTStop, cast ( Stop - Start as float ) as LenTime
		From (
			Select i.DTStart, i.DTStop, 
				case when ( os.DateTimeStart < i.DTStart ) then i.DTStart else os.DateTimeStart end as Start, 
				case when ( os.DateTimeStop > i.DTStop ) then i.DTStop else os.DateTimeStop end as Stop
			From #t3 os
				Inner join @intervals i on ( os.DateTimeStart between i.DTStart and i.DTStop ) or ( os.DateTimeStop between i.DTStart and i.DTStop )
			Where State = 8
		) a
	)b
	Group By DTStart, DTStop

	Update o
		Set SumLunch = tmp.LenTime
	From @output o, #tmp9 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp9

------------------------------------------------------------------------------------------------------
--   
	Select DTStart, DTStop, Sum ( LenTime ) LenTime into #tmp10
	From (
		Select DTStart, DTStop, cast ( Stop - Start as float ) as LenTime
		From (
			Select i.DTStart, i.DTStop, 
				case when ( os.DateTimeStart < i.DTStart ) then i.DTStart else os.DateTimeStart end as Start, 
				case when ( os.DateTimeStop > i.DTStop ) then i.DTStop else os.DateTimeStop end as Stop
			From #t3 os
				Inner join @intervals i on ( os.DateTimeStart between i.DTStart and i.DTStop ) or ( os.DateTimeStop between i.DTStart and i.DTStop )
			Where State = 10
		) a
	)b
	Group By DTStart, DTStop
	
	Update o
		Set SumFree = tmp.LenTime
	From @output o, #tmp10 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp10

------------------------------------------------------------------------------------------------------
--    -
	Select DTStart, DTStop, Sum ( LenTime ) LenTime into #tmp11
	From (
		Select DTStart, DTStop, cast ( Stop - Start as float ) as LenTime
		From (
			Select i.DTStart, i.DTStop, 
				case when ( os.DateTimeStart < i.DTStart ) then i.DTStart else os.DateTimeStart end as Start, 
				case when ( os.DateTimeStop > i.DTStop ) then i.DTStop else os.DateTimeStop end as Stop
			From #t3 os
				Inner join @intervals i on ( os.DateTimeStart between i.DTStart and i.DTStop ) or ( os.DateTimeStop between i.DTStart and i.DTStop )			
		) a
	)b
	Group By DTStart, DTStop

	Update o
		Set SumInCC = tmp.LenTime
	From @output o, #tmp11 tmp
	Where o.DTStart = tmp.DTStart

	Drop table #tmp11

------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------

	--  NULL  
	Update @output 
	Set TotalCntIncoming = 0
	Where TotalCntIncoming is null

	Update @output 
	Set AvgTalk1 = 0
	Where AvgTalk1 is null

	Update @output 
	Set AvgTalk2 = 0
	Where AvgTalk2 is null

	Update @output 
	Set AvgPost = 0
	Where AvgPost is null

	Update @output 
	Set AvgBusinessPerc = 0
	Where AvgBusinessPerc is null

	Update @output 
	Set SumTalk1 = 0
	Where SumTalk1 is null

	Update @output 
	Set SumTalk2 = 0
	Where SumTalk2 is null

	Update @output 
	Set SumPost = 0
	Where SumPost is null

	Update @output 
	Set SumLunch = 0
	Where SumLunch is null

	Update @output 
	Set SumFree = 0
	Where SumFree is null

	Update @output 
	Set SumInCC = 0
	Where SumInCC is null


	-- 
	Select * FROM @output
end
GO