if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_TaskManager_List_ClearIdColumnConstraint]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_TaskManager_List_ClearIdColumnConstraint]
GO

CREATE   procedure [dbo].[A_TaskManager_List_ClearIdColumnConstraint]
	@table nvarchar(255), 
	@column nvarchar(255)
as
begin
	declare @c_name nvarchar(255)
	declare @stmt nvarchar(500)
	if( exists( select constraint_name
		 from information_schema.CONSTRAINT_COLUMN_USAGE
		where table_name = @table and  constraint_name like 'PK%' ) ) begin	

		 select @c_name = constraint_name
		 from information_schema.CONSTRAINT_COLUMN_USAGE
		where table_name = @table and  constraint_name like 'PK%'
		set @stmt = 'alter table ' + @table + ' drop constraint ' + @c_name
		exec sp_executesql @stmt
	end
end
GO
