exec A_DB_ClearConstraints 'A_ClientForm'
exec A_DB_ClearConstraints 'A_ClientFormControl'
exec A_DB_ClearConstraints 'A_ClientFormList'
exec A_DB_ClearConstraints 'A_ClientFormRights'
exec A_DB_ClearConstraints 'A_Clients_ClientForms'

exec A_DB_ClearConstraints 'A_Contragent'
exec A_DB_ClearConstraints 'A_Contragent_ContragentGroup'
exec A_DB_ClearConstraints 'A_Contragent_KeyWords'
exec A_DB_ClearConstraints 'A_ContragentCategory'
exec A_DB_ClearConstraints 'A_ContragentCategory_Conditions'
exec A_DB_ClearConstraints 'A_ContragentCategory_GrantedForms'
exec A_DB_ClearConstraints 'A_ContragentCategory_GrantedLists'
exec A_DB_ClearConstraints 'A_Contragent_Rigths'
exec A_DB_ClearConstraints 'A_ContragentContact'
exec A_DB_ClearConstraints 'A_ContragentGroup'
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormControl_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormControl] DROP CONSTRAINT FK_A_ClientFormControl_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormList_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormList] DROP CONSTRAINT FK_A_ClientFormList_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormRigths_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormRigths] DROP CONSTRAINT FK_A_ClientFormRigths_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_ClientForms_A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_ClientForms] DROP CONSTRAINT FK_A_Clients_ClientForms_A_ClientFormControl
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_ClearRigths]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_ClearRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteForm]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_DeleteRemovedLists]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_DeleteRemovedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetFomListControls]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Lists_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Lists_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_Rigths_GetList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_Rigths_GetList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveCommon]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveCommon]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveFormControl]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Admin_ClientForm_SaveRigth]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[A_Admin_ClientForm_SaveRigth]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientForm]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormRigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients_ClientForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Clients_ClientForms]
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_ContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_KeyWords]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_KeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_Conditions]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_Conditions]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentCategory_GrantedLists]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentCategory_GrantedLists]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_Rigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_Rigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentContact]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentGroup]
GO



CREATE TABLE [dbo].[A_ClientForm] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (255) COLLATE database_default NOT NULL ,
	[ServerVersion] [datetime] NOT NULL ,
	[ClientVersion] [datetime] NOT NULL ,
	[idOwner] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_ClientFormControl] (
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (255) COLLATE database_default NOT NULL ,
	[idForm] [uniqueidentifier] NOT NULL ,
	[idType] [int] NOT NULL ,
	[IsActual] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_ClientFormList] (
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idForm] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (50) COLLATE database_default NOT NULL ,
	[IsActual] [bit] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_ClientFormRigths] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idSubject] [uniqueidentifier] NOT NULL ,
	[isGroup] [bit] NOT NULL ,
	[AccessType] [tinyint] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[A_Clients_ClientForms] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[idClient] [uniqueidentifier] NOT NULL ,
	[idValue] [uniqueidentifier] NOT NULL ,
	[ValueStr] [nvarchar] (2000) COLLATE database_default NULL ,
	[ValueInt] [int] NULL ,
	[ValueDate] [datetime] NULL ,
	[ValueDate2] [datetime] NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ClientForm] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientForm] PRIMARY KEY  CLUSTERED 
	(
		[idForm]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientFormControl] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientFormControl] PRIMARY KEY  CLUSTERED 
	(
		[idFormControl]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientFormList] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientFormList] PRIMARY KEY  CLUSTERED 
	(
		[idFormList]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Clients_ClientForms] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Clients_ClientForms] PRIMARY KEY  CLUSTERED 
	(
		[idValue]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientForm] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientForm_ServerVersion] DEFAULT (getdate()) FOR [ServerVersion],
	CONSTRAINT [DF_A_ClientForm_ClientVersion] DEFAULT (getdate()) FOR [ClientVersion]
GO

ALTER TABLE [dbo].[A_ClientFormControl] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientFormControl_IsActual] DEFAULT (1) FOR [IsActual]
GO

ALTER TABLE [dbo].[A_ClientFormList] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientFormList_IsActual] DEFAULT (1) FOR [IsActual]
GO

ALTER TABLE [dbo].[A_ClientFormRigths] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientFormRigths_isGroup] DEFAULT (0) FOR [isGroup],
	CONSTRAINT [DF_A_ClientFormRigths_Type] DEFAULT (1) FOR [AccessType]
GO

ALTER TABLE [dbo].[A_ClientFormControl] ADD 
	CONSTRAINT [FK_A_ClientFormControl_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ClientFormList] ADD 
	CONSTRAINT [FK_A_ClientFormList_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ClientFormRigths] ADD 
	CONSTRAINT [FK_A_ClientFormRigths_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_Clients_ClientForms] ADD 
	CONSTRAINT [FK_A_Clients_ClientForms_A_ClientFormControl] FOREIGN KEY 
	(
		[idFormControl]
	) REFERENCES [dbo].[A_ClientFormControl] (
		[idFormControl]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE     Procedure [dbo].[A_Admin_ClientForm_ClearRigths]
@@FormId uniqueidentifier
as
begin
 delete A_ClientFormRigths
 where idForm = @@FormId
end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE     Procedure [dbo].[A_Admin_ClientForm_DeleteForm]
@@FormId uniqueidentifier
as
begin
 delete A_ClientForm
 where idForm = @@FormId
end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE     Procedure [dbo].[A_Admin_ClientForm_DeleteRemovedControls]
@@FormId uniqueidentifier
as
begin
 delete A_ClientFormControl
 where idForm = @@FormId and IsActual = 0
 -- 
 update A_ClientFormControl
 set IsActual = 0
 where idForm = @@FormId
end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE     Procedure [dbo].[A_Admin_ClientForm_DeleteRemovedLists]
@@FormId uniqueidentifier
as
begin
 delete A_ClientFormList
 where idForm = @@FormId and IsActual = 0
 -- 
 update A_ClientFormList
 set IsActual = 0
 where idForm = @@FormId
end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE     Procedure [dbo].[A_Admin_ClientForm_GetFomListControls]
as
begin
 Select f.idForm, f.Name 'Form', fl.IdFormList, fl.Name 'List', fc.idFormControl, fc.Name 'Control'
 From A_ClientForm  f
	inner join A_ClientFormList fl on f.idForm = fl.idForm
		inner join A_ClientFormControl fc on f.idForm = fc.idForm
end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


CREATE     Procedure [dbo].[A_Admin_ClientForm_GetList]
as
begin
 Select f.idForm, f.Name, ServerVersion, ClientVersion, u.Id 'idUser', u.Name 'User'
 From A_ClientForm  f inner join A_Users u on f.IdOwner = u.Id
end


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


create     Procedure [dbo].[A_Admin_ClientForm_Lists_GetList]
as
begin
 Select idFormList, idForm, Name
 From A_ClientFormList
end


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO


create     Procedure [dbo].[A_Admin_ClientForm_Rigths_GetList]
as
begin
 Select idForm, idSubject, isGroup, AccessType
 From A_ClientFormRigths
end


GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE     Procedure [dbo].[A_Admin_ClientForm_SaveCommon]
@@Id uniqueidentifier,
@@Name nvarchar(255),
@@ClientVersion datetime,
@@ServerVersion datetime,
@@OwnerId uniqueidentifier
as
begin
if( not exists( select IdForm from A_ClientForm Where IdForm = @@Id ) ) begin --New Form Record
 insert A_ClientForm ( idForm, Name, ServerVersion, ClientVersion, idOwner )
 values ( @@Id, @@Name, @@ServerVersion, @@ClientVersion, @@OwnerId )
end
else  begin --Update existing
 update A_CLientForm
 set 	Name = @@Name,
	ServerVersion = @@ServerVersion,
	ClientVersion = @@ClientVersion,
	idOwner = @@OwnerId
 where idForm = @@Id
end

end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE      Procedure [dbo].[A_Admin_ClientForm_SaveFormControl]
@@Id uniqueidentifier,
@@Name nvarchar(255),
@@Type int,
@@FormId uniqueidentifier
as
begin

if( not exists( select idFormControl from A_ClientFormControl Where idFormControl = @@Id ) ) begin --New Form Control Record
	insert A_ClientFormControl ( idFormControl, Name, idForm, idType )
	values ( @@Id, @@Name, @@FormId, @@Type )
end
else  begin --Update existing
 update A_ClientFormControl
 set 	IsActual = 1
 where idFormControl = @@Id
end


end
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO




CREATE      Procedure [dbo].[A_Admin_ClientForm_SaveList]
@@Id uniqueidentifier,
@@Name nvarchar(255),
@@FormId uniqueidentifier
as
begin
if( not exists( select idFormList from A_ClientFormList Where idFormList = @@Id ) ) begin --New Form List Record
 insert A_ClientFormList ( idFormList, Name, idForm )
 values ( @@Id, @@Name, @@FormId )
end
else  begin --Update existing
 update A_ClientFormList
 set 	Name = @@Name,
 	IsActual = 1
 where idFormList = @@Id
end

end




GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO



CREATE     Procedure [dbo].[A_Admin_ClientForm_SaveRigth]
@@FormId uniqueidentifier,
@@SubjectId uniqueidentifier,
@@IsGroup bit,
@@AccessType nvarchar( 10 )
as
begin

declare @AccessType tinyint 
if( @@AccessType = 'editform' )
 set @AccessType = 1
else if ( @@AccessType = 'editdata' )
 set @AccessType = 2

insert A_ClientFormRigths ( idForm, idSubject, isGroup, AccessType )
values ( @@FormId, @@SubjectId, @@IsGroup, @AccessType )

end



GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

