if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_OperatorLastConnected_Get' ) )
	Drop procedure dbo.A_CallCenter_OperatorLastConnected_Get
GO

Create procedure dbo.A_CallCenter_OperatorLastConnected_Get
	@idtask uniqueidentifier,
	@idpoint int,
	@number nvarchar ( 30 ),
	@searchintask bit,
	@searchinnumbers bit
as
begin

if ( @searchintask = 1 )
begin
	if ( @searchinnumbers = 1 )
	begin
		Select Top 1 idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where IdTask = @idtask 
			and AbonentNumber = @number
			and IdOperator is not null
		Order by DateTimeStart Desc
	end
	else
	begin
		Select Top 1 idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where IdTask = @idtask 
			and IdInList = @idpoint
			and IdOperator is not null
		Order by DateTimeStart Desc
	end
end
else
begin
	if ( @searchinnumbers = 1 )
	begin
		Select Top 1 idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where AbonentNumber = @number
			and IdOperator is not null
		Order by DateTimeStart Desc
	end
	else
	begin
		Select Top 1 idoperator 
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections 
		Where IdInList = @idpoint
			and IdOperator is not null
		Order by DateTimeStart Desc
	end
end
	
end
GO
