if exists ( Select * FROM sysobjects where id=object_id ( 'dbo.A_TaskManager_UserResultsProject_GetForChoice' ))
	Drop procedure dbo.A_TaskManager_UserResultsProject_GetForChoice
GO

Create procedure dbo.A_TaskManager_UserResultsProject_GetForChoice
	@idproject uniqueidentifier
as
begin
	Declare @type int

	Select @type = UserResType 
	From A_TaskManager_Projects 
	Where Id = @idproject

	if ( @type = 0 )
		Select Id, Name, IsOutput, Success, IsDefault
		FROM A_TaskManager_CardUserResults
 	else if ( @type = 1 )
		Select Id, Name, IsOutput, Success, IsDefault
		FROM A_TaskManager_CardUserResultsProject where projectid = @idproject
	else 
	begin	
		Declare @tmp table ( Id int, Name nvarchar ( 200 ), IsOutput bit, Success bit, IsDefault bit )
		
		Insert into @tmp 
			Select Id, Name, IsOutput, Success, IsDefault
			FROM A_TaskManager_CardUserResultsProject

		Insert into @tmp
			Select Id, Name, IsOutput, Success, IsDefault
			FROM A_TaskManager_CardUserResults r
			Where not exists ( Select Id From @tmp Where Id = r.Id )

		Select * 
		From @tmp		
		Where Name != ''
	end
end
GO
